;===================================================================
;	I2C bus hard driver
;  - Lpa
; http://radioelektr.ru/
;-------------------------------------------------------------------
 ;#########################################
 ;####    I2C ######
 ;#########################################
speed_clk:		;   I2C
		ldi temp,5						;TWBR = ((8000000/300000) - 16)/(2*4^0) = 5
		OUT TWBR,temp					;   300    8 
		ldi temp, (0<<TWPS1)|(0<<TWPS0) ;  TWI  1 (TWPS=0)
		OUT TWSR,temp
		ret

;#########################################
;######    #######
;#########################################
IIC_Start: 		;  
		ldi temp,(1<<TWINT)|(1<<TWSTA)|(1<<TWEN);   
		OUT TWCR,temp
		rcall iic_wait							; ,    
		ret

;###################################
;####    ####
;###################################
IIC_Stop:		;   	
	ldi temp,(1<<TWINT)|(1<<TWEN)|(1<<TWSTO)	;   
	OUT TWCR,temp
	ret

;#########################
;######   ######
;#########################
iic_recieve: 
											;     temp
	ldi temp,(1<<TWINT)|(1<<TWEN)|(1<<TWEA)	;  
	OUT TWCR,temp	
	rcall iic_wait							; ,   
	in temp,TWDR							;  
	ret

;###########################################
;####    ( ACK) #####
;###########################################
iic_recieve_lst:		;     temp

	ldi temp,(1<<TWINT)|(1<<TWEN)	;  
	OUT TWCR,temp					;
	rcall iic_wait					; ,    
	in temp,TWDR					;  
	ret

;#########################################
;############   #############
;#########################################
iic_send: 	;     temp
	out TWDR,temp					;  
	ldi temp,(1<<TWINT)|(1<<TWEN)	;  
	OUT TWCR,temp					; 
	rcall iic_wait					; ,    
	ret

;#########################################
;####    ####
;#########################################
IIC_Wait:
	cli
	in temp,TWCR					;    TWCR    temp
	sbrs temp,TWINT					;     1 -  
	rjmp IIC_Wait					;   ,   
	sei
	ret



.EXIT
